import { createRoute } from "../../../modules/api-utils/createRoute";
import { unifiSites } from "../../../managers/unifiSites";
import { apiResponse } from "../../../modules/api-utils/apiResponse";
import { ContentfulStatusCode } from "hono/utils/http-status";
import { authMiddleware } from "../../middleware/authorization";

/* GET /v1/unifi/site/:id/ap-groups */
export default createRoute(
  "get",
  ["/site/:id/ap-groups"],
  async (c) => {
    const site = await unifiSites.fetch(c.req.param("id"));
    const apGroups = await unifiSites.getApGroups(site.siteId);
    const response = apiResponse.successful(
      "UniFi AP Groups Fetched Successfully!",
      apGroups,
    );
    return c.json(response, response.status as ContentfulStatusCode);
  },
  authMiddleware({
    permissions: ["unifi.access", "unifi.site.ap-groups"],
  }),
);
